/*
 * Created on 14-Sep-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package uk.ac.vamsas.client;

/**
 * @author jimp
 * middleware interface for generating new VorbaId objects 
 * for a particular vamsas client based on the current 
 * session, user and client handle. Generally implemented 
 * by instances of the vamsas library api only.
 */
public interface IVorbaIdFactory {
  /**
   * construct a new id appropriate for this client in the vamsas session.
   * @param vobject TODO
   * 
   * @return valid VorbaId for session, or null if VorbaIdFactory not configured
   *         correctly.
   */
  public abstract VorbaId makeVorbaId(Vobject vobject);

  public abstract SessionHandle getSessionHandle();

  public abstract ClientHandle getClientHandle();

  public abstract UserHandle getUserHandle();
  /**
   * called when an object is touched by the vamsas library prior to writing
   * to record last hash for the object's VorbaId
   * @param vobject
   */
  public abstract void updateHashValue(Vobject vobject);
}